// MatrixEdit.cpp : implementation file
//

#include "stdafx.h"
#include "moviemat.h"
#include "MatrixEdit.h"
#include "memdc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatrixEdit

CMatrixEdit::CMatrixEdit()
{
	RegisterWndClass();

	// Intitialisierung

	m_Size_x = 16;
	m_Size_y = 8;
	m_shades = 2;
	m_pContent = (char*)calloc(m_Size_x * m_Size_y,1);

}

CMatrixEdit::~CMatrixEdit()
{
	free (m_pContent);
}


BEGIN_MESSAGE_MAP(CMatrixEdit, CWnd)
	//{{AFX_MSG_MAP(CMatrixEdit)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_CREATE()
	ON_WM_RBUTTONDOWN()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMatrixEdit message handlers

BOOL CMatrixEdit::RegisterWndClass()
{

	WNDCLASS windowclass;
    HINSTANCE hInst = AfxGetInstanceHandle();     //Check weather the class is registerd already
    if (!(::GetClassInfo(hInst, MATRWNDCLASS, &windowclass)))
    {
        //If not then we have to register the new class
        windowclass.style = CS_DBLCLKS;// | CS_HREDRAW | CS_VREDRAW;
        windowclass.lpfnWndProc = ::DefWindowProc;
        windowclass.cbClsExtra = windowclass.cbWndExtra = 0;
        windowclass.hInstance = hInst;
        windowclass.hIcon = NULL;
        windowclass.hCursor = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
        windowclass.hbrBackground = ::GetSysColorBrush(COLOR_WINDOW);
        windowclass.lpszMenuName = NULL;
        windowclass.lpszClassName = MATRWNDCLASS;         if (!AfxRegisterClass(&windowclass))
        {
            AfxThrowResourceException();
            return FALSE;
        }
    }     return TRUE;
}

void CMatrixEdit::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
    CMemDC Mydc(&dc);

	//---- Grid zeichnen ----

	// Schwarzer Pen
	COLORREF col = 0x00000022;


	CRect ClientRect;
    GetClientRect(ClientRect);

	Mydc.FillSolidRect(ClientRect, col);

	m_x = ClientRect.right;
	m_y = ClientRect.bottom;

	m_gridsize_x = m_x / m_Size_x;
	m_gridsize_y = m_y / m_Size_y;

	m_restx = (m_x-(m_gridsize_x * m_Size_x))/2;
	m_resty = (m_y-(m_gridsize_y * m_Size_y))/2;

	col = 0x000000FF;

	unsigned char Value;

	for (int i_x = 0; i_x < m_Size_x;i_x++)
	{
		for (int i_y = 0; i_y < m_Size_y;i_y++)
		{
			
			Value = m_pContent[i_x+(i_y*m_Size_x)]; 

			if (Value != 0)
			{
				//SetElement(i_x, i_y, m_pContent[i_x*i_y]);	

				col = 0x00000001 * Value;
				if (Value == 0)
				{
					col = 0x00000022;
				}


				CRect ElementRect;

				ElementRect.left = i_x*m_gridsize_x + m_restx;
				ElementRect.right = ElementRect.left +m_gridsize_x;

				ElementRect.top = i_y*m_gridsize_y + m_resty;
				ElementRect.bottom = ElementRect.top+m_gridsize_y;

				//ElementRect.left;
				ElementRect.top++;

				Mydc.FillSolidRect(ElementRect, col);

			}
		}
	}

	col = 0x00444444;
	CPen myPen1( PS_SOLID, 1, col );
	CPen * oldPen ;
	oldPen = Mydc.SelectObject(&myPen1);

	for (int i = 1; i < m_Size_x;i++)
	{
		Mydc.MoveTo(m_restx+i*m_gridsize_x,m_resty+1);
		Mydc.LineTo(m_restx+i*m_gridsize_x,m_y-1-m_resty);
	}

	for ( i = 1; i < m_Size_y;i++)
	{
		Mydc.MoveTo(m_restx+1,m_resty+i*m_gridsize_y);
		Mydc.LineTo(m_x-1-m_restx, m_resty+i*m_gridsize_y);
	}
	
	Mydc.SelectObject(oldPen);
}

//
//  Neue Dimension setzen
//	0 : Fehler
// 	1 : Okay
//

int CMatrixEdit::SetSize(int x, int y, int shades)
{
	char* NewContent;
	int retwert = 1;
	
	// alter Inhalt und Size okay?
	if ((m_pContent) &&  (0 != x) && (0 != y) & (0!=shades))
	{
		
		NewContent = (char*)calloc(x * y,1);
		
		// Neuer Inhalt mglich?
		if (NewContent)
		{
			free(m_pContent);
			m_Size_x = x;
			m_Size_y = y;
			m_shades = shades;
			m_pContent = NewContent;
		}
		else
		{
			retwert = 0;
		}
	}
	else
	{
		retwert = 0;
	}

	RedrawWindow();

	return retwert;
}

int CMatrixEdit::SetContent(char *pContent)
{
	int retwert = 1;

	if (NULL != pContent)
	{
		memcpy(m_pContent,pContent,m_Size_x*m_Size_y);
	}


	RedrawWindow();

	return retwert;
}

char* CMatrixEdit::GetContent()
{
	return m_pContent;
}

int CMatrixEdit::SetElement(int x, int y, int Value)
{
	int retwert = 1;

	//CPaintDC dc(this); // device context for painting

	if((x<m_Size_x) && (y<m_Size_y))
	{

		CDC *d=GetDC();

		//CMemDC Mydc(&dc);

		CRect ElementRect;

		ElementRect.left = x*m_gridsize_x+1 + m_restx;
		ElementRect.right = ElementRect.left +m_gridsize_x-1;

		ElementRect.top = y*m_gridsize_y + m_resty;
		ElementRect.bottom = ElementRect.top+m_gridsize_y;

		//ElementRect.left++;
		ElementRect.top++;

		COLORREF col = 0x00000001 * Value;

		if (Value == 0)
		{
			col = 0x00000022;
		}

		d->FillSolidRect(ElementRect, col);
		
		m_pContent[x + (y*m_Size_x)]=Value;
	
		ReleaseDC(d);
		//RedrawWindow();
	}
	else
	{
		retwert = 0;
	}

	return retwert;
}

void CMatrixEdit::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	int x = (point.x-m_restx)/m_gridsize_x;
	int y = (point.y-m_resty)/m_gridsize_y;

	unsigned char value = GetElement(x,y);
	
	if (value == 0)
	{
		value = 255;
	}
	else
	{
		value -= 256/m_shades;
	}

	SetElement(x,y,value);

	//CWnd::OnLButtonDown(nFlags, point);
}

int CMatrixEdit::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
	return 0;
}

void CMatrixEdit::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	int x = (point.x-m_restx)/m_gridsize_x;
	int y = (point.y-m_resty)/m_gridsize_y;

	SetElement(x,y,0);

	//CWnd::OnRButtonDown(nFlags, point);
}

BOOL CMatrixEdit::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
	
	//return CWnd::OnEraseBkgnd(pDC);

	return FALSE;
}

int CMatrixEdit::MoveUp()
{
	
	memmove(m_pContent,(char*)&m_pContent[m_Size_x],m_Size_x*(m_Size_y-1));
	memset((char*)&m_pContent[m_Size_x*(m_Size_y-1)],0,m_Size_x);
	RedrawWindow();

	return 1;
}

int CMatrixEdit::MoveDown()
{
	
	memmove((char*)&m_pContent[m_Size_x],m_pContent,m_Size_x*(m_Size_y-1));
	memset(m_pContent,0,m_Size_x);
	RedrawWindow();

	return 1;

}

int CMatrixEdit::MoveRight()
{
	for (int y=0; y < m_Size_y; y++)
	{
		memmove((char*)&m_pContent[1+m_Size_x*y],(char*)&m_pContent[m_Size_x*y],(m_Size_x-1));
		m_pContent[m_Size_x*y]=0;
	}
	RedrawWindow();
   return 1;
}

int CMatrixEdit::MoveLeft()
{
	for (int y=0; y < m_Size_y; y++)
	{
		memmove((char*)&m_pContent[m_Size_x*y],(char*)&m_pContent[1+m_Size_x*y],(m_Size_x-1));
		m_pContent[(m_Size_x*(y+1))-1]=0;
	}
	RedrawWindow();
   return 1;
}

int CMatrixEdit::GetElement(int x, int y)
{
	
	return m_pContent[x + (y*m_Size_x)];
}
